/*
** file: isll.cpp
**
** Integer Single Linked List
** UC: 21046 - EDAF @ UAb
** e-fólio A 2022-23
**
** Aluno: 2000809 - Pedro Santos
*/

// Defina:
// em file.h as classes da estrutura de dados
// em file.cpp a implementação dos métodos das classes da estrutura de dados

#include <iostream>
#include "isll.h"



INode::INode() { //Constructor No
   next = nullptr;
}

INode::~INode() { //Destructor No
    next = nullptr;
    item = 0;
}

ISll::ISll() { //Constructor Lista
      head = tail = nullptr;
      n=0;
   }
   
ISll::~ISll() { //Destructor Lista
    for (INode *aux; n!=0; n--) {
        aux = head->next;
        delete head;
        head = aux;
    }
}
   
int ISll::isEmpty() {// verifica se a lista está vazia
   return n == 0;
}


int ISll::getn() {
    return n;
} //devolve o valor de n   
   
void ISll::insert_0(int item){
    
    INode *aux = new INode(); //cria novo no
    aux->item=item;
    aux->next = head;
    head = aux; //na head da lista
    
    if(isEmpty()) //caso a lista esteja vazia, o no e tanto head como tail
       tail=head;
       
    n++;
} //Insere no inicio o item 

void ISll::insert_end(int item){
    
    INode *aux = new INode(); //cria novo no
    aux->item=item;
    aux->next=nullptr;
    
    if(isEmpty()){//caso esteja vazia, o no é tanto head como tail
       tail=aux;
       head=tail;
    }
    else{
    tail->next=aux;
    tail=aux; // na tail da lista
    }
    
    n++;
}//Insere no fim

void ISll::print_0(){
    std::cout << "Lista(0)= " << head->item << std::endl;
    
} //imprime 1º item "Lista(0)= %d\n"

void ISll::print_end(){
    std::cout << "Lista(end)= " << tail->item << std::endl;
}//imprime ultimo item "Lista(end)= %d\n"

void ISll::print(){
    
    INode *aux = head;
    
    std::cout << "Lista=";
    
    for(;aux!=nullptr;aux=aux->next)//enquanto o nó nao for nulo(Enquanto nao passar o fim da lista) imprime a lista
       std::cout << " " << aux->item;
    
    std::cout << std::endl;
}//imprime toda a lista "Lista= %d %d ...\n"


void ISll::delete_0(){
    
    INode *aux;
    
    if(n==1){
        head = tail = nullptr;
        delete aux;
    }
    else{
        aux = head->next;
        delete head;
        head=aux;
    }
    
    n--;
}//remove 1º no

void ISll::delete_end(){
    
    INode *aux = head;
    
    if(n==1){
        head = tail = nullptr;
        delete aux;
    }
    else{
        for(;aux->next!=tail;aux=aux->next);
        
        delete tail;
        tail = aux;
        tail->next = nullptr;
    }
    
    n--;
}//remove ultimo no

void ISll::delete_pos(int pos){
    
    INode *aux = head;
    
    
    if(pos==0){//Se a posicao for 0(a head) elimina head
        if(n!=1){
            head=head->next;
        }
        else{//Se a lista so tiver 1 elemento
            head = tail = nullptr;
        }
        delete aux;
    }
    else{//Caso contrario, procura essa posicao 
        INode *tmp=aux;
        
        for(int i=0;i!=pos;i++){
            aux=tmp;
            tmp=tmp->next;
        }
        
        aux->next = tmp->next;//e elimina-a
        delete tmp;
        
        if(pos==n-1)//Se a posicao for a ultima da lista, atualizar o apontador da tail par ao precedente
            tail=aux;
    }
    n--;
}//remove posição x (pos 0 = 1ª)

void ISll::clear(){
    
    INode *aux=head;
    INode *tmp;
    
    while(aux!=nullptr)//Enquanto houver nos
    {
        tmp=aux;
        aux=aux->next;
        delete tmp;//elimina-os
    }
    
    n=0;//mete o numero de elementos igual a 0, pois foram todos eliminados
}//remove todos os nos

void ISll::dim(){
    std::cout << "Lista tem " << n << " itens" << std::endl;
}//imprime nro de items na lista "Lista tem %d itens\n"

void ISll::find(int itm){
    INode *aux=head;
    
    for(int i=0;aux!=nullptr;aux=aux->next,i++)//Procura toda a lista
    {
        if(aux->item==itm){//caso encontre (logo na primeira ocurrencia) imprime a informacao e retorna, para nao gastar tempo desnecessario
            std::cout << "Item " << itm << " na posicao " << i <<  std::endl;
            return;
        }
    }
    
    std::cout << "Item " << itm << " nao encontrado!" << std::endl;//caso contrario, retorna informacao que nao encontrou
}//Imprime a posição da 1ª ocurrencia do item - "Item %d na posicao %d\n" ou "Item %d nao encontrado!\n"

void ISll::find_max(){
    INode *aux = head;
    int pos=0, itm = head->item; // inicia itm com o primeiro itm, para guardar valor para comparar
    
    for(int i=0;aux!=nullptr;aux=aux->next,i++)//Procura toda a lista
    {
        if(aux->item>itm){//Caso item a testar seja maior
            itm=aux->item;//Guarda item sempre que encontrar um item maior que o guardado
            pos=i;//e a sua posicao
        }
    }
    
    std::cout << "Max Item " << itm << " na posicao " << pos << std::endl;
    
}//Imprime a primeira ocorrência do maior item na lista e imprime a sua posição "Max Item %d na posicao %d\n"

void ISll::invert_range(int pos1,int pos2){
    
    ISll L_aux;//cria lista auxiliar
    INode *aux=head;//copia no inicial
    INode *checkpoint=head; /*inicializar checkpoint, no caso de pos1=0. Serve para guardar um ponto para continuar depois de passar para a lista aux.*/
    int i;
    
    for(i=0;i<pos1;i++){//procura posicao 1
        checkpoint=aux;
        aux=aux->next;
    }
    
    for(int j=i;j<=pos2;j++){//guarda no a inverter, ja na posicao requerida
        L_aux.insert_0(aux->item);
        aux=aux->next;
    }
    
    INode *add;
    
    if(pos1!=0)/*caso a posicao nao seja 0, checkpoint e o no imediatamente antes do primeiro no dentro do "range" para inverter */
        add=checkpoint->next;/*Logo, queremos o no imediatamente a seguir para comecar a trocar*/
    else/*caso a posicao seja 0, queremos logo comecar a mudar na posicao de head*/
        add=head;
        
    for(;i<=pos2;i++){//com a lista auxiliar, copia-se os valores para a lista principal
        add->item=L_aux.head->item;
        add=add->next;
        L_aux.delete_0();//apagando no a no a lista auxiliar
    }
    
}//Inverte a ordem entre pos1 e pos2 (criar lista aux, remover e reinserir os items em causa)

// EOF

